#include "test.hpp"

typedef TestTmpFile<docra::Lexer_Vhdl> TestVhdlTmpFile;

TEST_F(TestVhdlTmpFile, Vhdl0) {
  wl("library ieee;");
  wl("use ieee.std_logic_1164.all;");
  wl("");
  wl("-- this is a comment");
  wl("entity foo is end; --another comment");
  we();

  CASSERT_CODE("library ieee;", 0);
  CASSERT_CODE("use ieee.std_logic_1164.all;", 0);
  CASSERT_CODE("", 0);
  CASSERT_CODE("", 0);
  CASSERT_COMM(" this is a comment", 0);
  CASSERT_CODE("entity foo is end; ", 0);
  CASSERT_COMM("another comment", 0);
  CASSERT_EOF();
}

TEST_F(TestVhdlTmpFile, Vhdl1) {
  wl("library ieee;");
  wl("use ieee.std_logic_1164.all;");
  wl("");
  wl("entity my_not is");
  wl("  port ( a : in  std_logic;");
  wl("         o : out std_logic);");
  wl("end entity my_not;");
  wl("architecture rtl of my_not is");
  wl("begin");
  wl("  o <= not a;");
  wl("end architecture my_not;");
  wl("entity my_or is");
  wl("  port (");
  wl("    a : in  std_logic;");
  wl("    b : in  std_logic;");
  wl("    o : out std_logic");
  wl("  );");
  wl("end entity;");
  wl("architecture rtl of my_or is");
  wl("begin");
  wl("  proc : process (a, b)");
  wl("  begin");
  wl("    o <= a or b;");
  wl("  end process;");
  wl("end architecture;");
  wl("entity my_and is");
  wl("  port (");
  wl("    a : in  std_logic;");
  wl("    b : in  std_logic;");
  wl("    o : out std_logic");
  wl("  );");
  wl("end my_and;");
  wl("architecture rtl of my_and is");
  wl("begin");
  wl("  o <= a and b;");
  wl("end my_and;");
  we();

  TASSERT_CODE("library ieee;");
  TASSERT_CODE("use ieee.std_logic_1164.all;");
  TASSERT_CODE("");
  TASSERT_CODE("entity my_not is");
  TASSERT_SIN();
  TASSERT_CODE("  port ( a : in  std_logic;");
  TASSERT_CODE("         o : out std_logic);");
  TASSERT_CODE("end entity my_not;");
  TASSERT_SOUT();
  TASSERT_CODE("architecture rtl of my_not is");
  TASSERT_SIN();
  TASSERT_CODE("begin");
  TASSERT_CODE("  o <= not a;");
  TASSERT_CODE("end architecture my_not;");
  TASSERT_SOUT();
  TASSERT_CODE("entity my_or is");
  TASSERT_SIN();
  TASSERT_CODE("  port (");
  TASSERT_CODE("    a : in  std_logic;");
  TASSERT_CODE("    b : in  std_logic;");
  TASSERT_CODE("    o : out std_logic");
  TASSERT_CODE("  );");
  TASSERT_CODE("end entity;");
  TASSERT_SOUT();
  TASSERT_CODE("architecture rtl of my_or is");
  TASSERT_SIN();
  TASSERT_CODE("begin");
  TASSERT_CODE("  proc : process (a, b)");
  TASSERT_SIN();
  TASSERT_CODE("  begin");
  TASSERT_CODE("    o <= a or b;");
  TASSERT_CODE("  end process;");
  TASSERT_SOUT();
  TASSERT_CODE("end architecture;");
  TASSERT_SOUT();
  TASSERT_CODE("entity my_and is");
  TASSERT_SIN();
  TASSERT_CODE("  port (");
  TASSERT_CODE("    a : in  std_logic;");
  TASSERT_CODE("    b : in  std_logic;");
  TASSERT_CODE("    o : out std_logic");
  TASSERT_CODE("  );");
  TASSERT_CODE("end my_and;");
  TASSERT_SOUT();
  TASSERT_CODE("architecture rtl of my_and is");
  TASSERT_SIN();
  TASSERT_CODE("begin");
  TASSERT_CODE("  o <= a and b;");
  TASSERT_CODE("end my_and;");
  TASSERT_SOUT();
  TASSERT_EOF();
}